/******************************************************************************
 *	flditem.c:		_CAȌ֐
 ******************************************************************************
 *	Workroom SX-68K Sample Program Copyright 1994 SHARP
 */
#include <console.h>		/* R\[n}l[W𗘗pƂɕKv */
#include <sxgraph.h>		/* Otn}l[W𗘗pƂɕKv */
#include <window.h>		/* EBhE}𗘗pƂɕKv	*/
#include <dialog.h>		/* _CAO}𗘗pƂɕKv	*/
#include <text.h>		/* eLXg}𗘗pƂɕKv	*/
#include <task.h>		/* ^XN}𗘗pƂɕKv	*/
#include "file.h"		/* ̃vOŗL̃wb_t@C	*/

static int dlgMode;			/* _CAO[h		*/

static short funcKeyTbl[] = {		/* t@NVL[ATCe[u */
	K_HOME,  0,			/* [HOME]	*/
	K_DEL,   0x07,			/* [DEL]	*/
	K_RUP,   0x03,			/* [ROLL UP]	*/
	K_RDOWN, 0x12,			/* [ROLL DOWN]	*/
	K_UNDO,  0,			/* [UNDO]	*/
	K_LEFT,  0x13,			/* []		*/
	K_UP,    0x05,			/* []		*/
	K_RIGHT, 0x04,			/* []		*/
	K_DOWN,  0x18,			/* []		*/
	K_CLR,   0,			/* [CLR]	*/
	K_HELP,  0,			/* [HELP]	*/
	K_INS,   0,			/* [INS]	*/
	0, 0				/* e[uI[	*/
};

/******************************************************************************
 *	dialogProc():	_CAO̍쐬A\Ɗe폈
 ******************************************************************************
 *	:	ComVal *pcv	ʕϐւ̃|C^
 *		DlgPrm *pdp	_CAOpp[^ւ̃|C^
 *	߂l:	int num		I_CAOACe̔ԍ
 *				= 1: [s]{^
 *				= 2: []{^
 *				< 0: s
 */
int dialogProc(ComVal *pcv, DlgPrm *pdp)
{
	int num;			/* _CAÕACeԍ	*/
	int lastBC;
	Rect rc;
	Handle dIListHdl;
	Graph *lastGraph;
	Dialog dialog;			/* _CAOR[h		*/
	Dialog *dialogPtr = &dialog;	/* _CAO|C^i^|C^j*/

	static Rect dlgPos[2] = {	/* _CAO̕\ʒu		*/
		/* ͗P */
		{ DLG1_X, DLG1_Y, DLG1_X + DLG1_H, DLG1_Y + DLG1_V },
		/* ͗Q */
		{ DLG2_X, DLG2_Y, DLG2_X + DLG2_H, DLG2_Y + DLG2_V }
	};

	/* _CAOACẽ\[Xǂݍ */
	dIListHdl = TSRscGet('DITL', pdp->mode + 127);
	if (dIListHdl == NULL) {
		pcv->errorCode = 14;	/* ǂݍ߂Ȃ		*/
		return -1;		/* ŝŁ|PԂ	*/
	}

	/* _CAO̕\ʒu␳ */
	TSAdjustRect(&rc, &dlgPos[pdp->mode - 1], 16);
	dialogPtr = DMOpen(		/* _CAOI[v	*/
		dialogPtr,		/* pӂ_CAO|C^	*/
		&rc,			/* _CAO̕\ʒu		*/
		NONTITLE,		/* ^Cg͎ŕ`悷	*/
		FALSE,			/* I[vɕ`悵Ȃ	*/
		WI_DLG << 4,		/* _CAOEBhE		*/
		W_FRONT,		/* ԎOɕ\		*/
		FALSE,			/* N[Y{^gpȂ	*/
		LONGWORD(1, TSGetID()),	/* ̃^XNhc		*/
		dIListHdl);		/* ACeXgւ̃nh	*/
	if (dialogPtr == NULL) {
		pcv->errorCode = 7;	/* 쐬łȂ		*/
		return -1;		/* ŝŁ|PԂ	*/
	}
	/* t@NVL[ATCe[uݒ肷 */
	(*dialogPtr->tEdit)->funcCode = funcKeyTbl;
	/* ҏW\eLXg̕NA */
	setDItemText(dialogPtr, 3, NONTITLE);
	if (pdp->mode == 2)
		setDItemText(dialogPtr, 4, NONTITLE);

	WMShow(&dialogPtr->window);	/* _CAO\		*/
	/* _CAOJgOtɂ */
	lastGraph = GMExgGraph(&dialogPtr->window.graph);

	/* ^Cg`悷 */
	GMShadowStrZ(pdp->title, LONGWORD((DLG1_H - pdp->len * 6) / 2, 4));
	GMShadowStrZ(pdp->str1, LONGWORD(16, 28));
	if (pdp->mode == 2)
		GMShadowStrZ(pdp->str2, LONGWORD(16, 76));
	lastBC = GMBackColor(G_WHITE);	/* obNOEhJ[𔒂ɂ */
	DMDraw(dialogPtr);		/* ׂẴACe`悷	*/

	dlgMode = pdp->mode;		/* _CAO[hݒ肷 */
	while (1) {
		/* AґACe܂ŁAACe̊e폈
		   VXeɔCāAꂽACe̔ԍ擾 */
		num = DMControl(filterProc);
		if (num == 1) {
			/* [s]{^̏ */
			/* ҏW\eLXgP̕擾 */
			getDItemText(dialogPtr, 3, pdp->src);
			if (pdp->mode == 2)
				/* ҏW\eLXgQ̕擾 */
				getDItemText(dialogPtr, 4, pdp->dst);
			break;
		} else if (num == 2)
			/* []{^̏ */
			break;
	}
	GMBackColor(lastBC);		/* obNOEhJ[ɖ߂ */
	DMClose(dialogPtr);		/* _CAON[Y	*/
	GMSetGraph(lastGraph);		/* JgOtɖ߂	*/

	/* ̂ŃACeԍԂ */
	return num;
}

/******************************************************************************
 *	filterProc():	_CAÕtB^֐
 ******************************************************************************
 *	:	Dialog *dlgPtr	_CAO|C^
 *		Event *pev	CxgR[hւ̃|C^
 *	߂l:	int IR[hił́AɂOj
 *	:
 *	DMControlĂяoAJ[\̓_ŏƁA^[L[^ESCL[
 *	͂[ݒ]^[]{^̃}EX_ECxgɕϊ鏈sB
 */
int filterProc(Dialog *dlgPtr, Event *pev)
{
	int keyCode;			/* L[R[h			*/
	int num = 0;			/* _CAÕACeԍ	*/
	short type;
	Rect rc, rc1, rc2;
	Handle item;

	/* _CAOJgOtɂ */
	GMSetGraph(&dlgPtr->window.graph);

	DIGet(dlgPtr, 3, &type, &item, &rc1);
	if (dlgMode == 2)
		DIGet(dlgPtr, 4, &type, &item, &rc2);
	switch (pev->what) {		/* Cxg̎ނ́H		*/
	case E_IDLE:			/* AChCxg		*/
		TMIdle(dlgPtr->tEdit);	/* J[\_ł		*/
		break;
	case E_KEYDOWN:			/* L[_ECxg		*/
		/* L[R[ht@NVL[ATCe[uŕϊ */
		keyCode = TMKeyToAsk(dlgPtr->tEdit, (TsEvent *) pev);
		/* L[R[h邩H */
		if (keyCode != -1 && keyCode != 0) {
			switch (pev->whom.key.ascii) {
			case '\r':	/* ^[L[ENTERL[	*/
				if ((*dlgPtr->tEdit)->view.l.l_t == rc1.l.l_t)
					/* _CAO[hQ̏ꍇA
					   ̕ҏWeLXgֈڂ */
					num = (dlgMode == 2) ? 4 : 1;
				else if (dlgMode == 2
					&& (*dlgPtr->tEdit)->view.l.l_t == rc2.l.l_t)
					num = 1; /* [s]{^	*/
				break;
			case '\x1b':	/* ESCL[			*/
				num = 2; /* []{^		*/
				break;
			}
			if (num != 0) {
				/* wACẽN^OwW
				   쐬 */
				DIGet(dlgPtr, num, &type, &item, &rc);
				/* cShbgֈړ */
				rc.d.left += 4;
				rc.d.top += 4;
				/* O[oWnɕϊ */
				pev->where.x_y = GMLocalToGlobal(rc.l.l_t);
				/* Cxg}EX_ECxgɂ */
				pev->what = E_MSLDOWN;
			}
		}
		break;
	case E_UPDATE:			/* Abvf[gCxg		*/
		/* J[\_ł邽߂ɁAAbvf[gs */
		WMUpdate(&dlgPtr->window); /* Abvf[gJn	*/
		WMUpdtOver(&dlgPtr->window); /* Abvf[gI	*/
		break;
	}
	return 0;
}

/******************************************************************************
 *	setDItemText():	_CAOACe̕ҏW\eLXgւ̐̕ݒ
 ******************************************************************************
 *	:	Dialog *dlgPtr	_CAO|C^
 *		int num		_CAÕACeԍ
 *		_LASCII str	ݒ肷LASCII^
 */
void setDItemText(Dialog *dlgPtr, int num, _LASCII str)
{
	short type;
	Rect rc;
	Handle item;

	/* _CAOACẽnh擾 */
	DIGet(dlgPtr, num, &type, &item, &rc);
	DITSet(type, item, str);	/* ҏW\eLXgɕݒ肷 */
}

/******************************************************************************
 *	getDItemText():	_CAOACe̕ҏW\eLXg̎̕擾
 ******************************************************************************
 *	:	Dialog *dlgPtr	_CAO|C^
 *		int num		_CAÕACeԍ
 *		_LASCII str	LASCII^i[|C^
 */
void getDItemText(Dialog *dlgPtr, int num, _LASCII str)
{
	short type;
	Rect rc;
	Handle item;

	/* _CAOACẽnh擾 */
	DIGet(dlgPtr, num, &type, &item, &rc);
	DITGet(type, item, str);	/* ҏW\eLXg̕擾 */
	str[str[0] + 1] = 0;		/* ̍ŌɂOt	*/
}
